/*
 * Copyright 2015-2016 Red Hat, Inc, and individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.hal.ballroom.table;

import org.jboss.hal.resources.Ids;

/** An action in a table row (typically in the last column) */
public class InlineAction<T> {

    final String id;
    final String title;
    final InlineActionHandler<T> handler;

    public InlineAction(String title, InlineActionHandler<T> handler) {
        this.id = Ids.uniqueId();
        this.title = title;
        this.handler = handler;
    }
}
