package org.jboss.hal.client.configuration;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;
import javax.inject.Inject;

import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import elemental2.dom.HTMLElement;
import org.jboss.gwt.elemento.core.builder.ElementsBuilder;
import org.jboss.gwt.elemento.core.Elements;
import org.jboss.gwt.elemento.template.TemplateUtil;
import org.jboss.hal.ballroom.form.Form;
import org.jboss.hal.ballroom.table.Scope;
import org.jboss.hal.ballroom.LayoutBuilder;
import org.jboss.hal.ballroom.autocomplete.ReadChildrenAutoComplete;
import org.jboss.hal.ballroom.VerticalNavigation;
import org.jboss.hal.core.mbui.dialog.AddResourceDialog;
import org.jboss.hal.core.mbui.form.GroupedForm;
import org.jboss.hal.core.mbui.form.ModelNodeForm;
import org.jboss.hal.core.mbui.table.ModelNodeTable;
import org.jboss.hal.core.mbui.MbuiContext;
import org.jboss.hal.dmr.Operation;
import org.jboss.hal.dmr.ResourceAddress;
import org.jboss.hal.meta.AddressTemplate;
import org.jboss.hal.meta.Metadata;
import org.jboss.hal.meta.security.Constraint;
import org.jboss.hal.resources.Ids;
import org.jboss.hal.spi.Message;
import org.jboss.hal.spi.MessageEvent;

import static java.util.Arrays.asList;
import static org.jboss.gwt.elemento.core.Elements.*;
import static org.jboss.hal.ballroom.LayoutBuilder.column;
import static org.jboss.hal.ballroom.LayoutBuilder.row;
import static org.jboss.hal.dmr.ModelDescriptionConstants.ADD;
import static org.jboss.hal.dmr.ModelDescriptionConstants.READ_RESOURCE_OPERATION;

/*
 * WARNING! This class is generated. Do not modify.
 */
@Generated("org.jboss.hal.processor.mbui.MbuiViewProcessor")
public final class Mbui_SocketBindingGroupView extends SocketBindingGroupView {

    private final Metadata metadata55;
    private final Metadata metadata54;
    private final Metadata metadata53;
    private final Map<String, HTMLElement> expressionElements;

    @Inject
    @SuppressWarnings("unchecked")
    public Mbui_SocketBindingGroupView(MbuiContext mbuiContext) {
        super(mbuiContext);

        AddressTemplate metadata55Template = AddressTemplate.of("/socket-binding-group=*/remote-destination-outbound-socket-binding=*");
        this.metadata55 = mbuiContext.metadataRegistry().lookup(metadata55Template);
        AddressTemplate metadata54Template = AddressTemplate.of("/socket-binding-group=*/local-destination-outbound-socket-binding=*");
        this.metadata54 = mbuiContext.metadataRegistry().lookup(metadata54Template);
        AddressTemplate metadata53Template = AddressTemplate.of("/socket-binding-group=*");
        this.metadata53 = mbuiContext.metadataRegistry().lookup(metadata53Template);
        this.expressionElements = new HashMap<>();

        configurationForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("socket-binding-group-configuration-form", metadata53)
            .include("default-interface", "includes")
            .unsorted()
            .onSave((form, changedValues) -> presenter.saveSocketBindingGroup(changedValues))
            .prepareReset(form -> presenter.resetSocketBindingGroup(form))
            .build();
        outboundLocalForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("socket-binding-group-outbound-local-form", metadata54)
            .include("socket-binding-ref", "source-interface", "source-port", "fixed-source-port")
            .unsorted()
            .onSave((form, changedValues) -> presenter.saveSocketBinding(SocketBinding.OUTBOUND_LOCAL, form, changedValues))
            .prepareReset(form -> presenter.resetSocketBinding(SocketBinding.OUTBOUND_LOCAL, form))
            .build();
        outboundLocalForm.getFormItem("socket-binding-ref").registerSuggestHandler(new ReadChildrenAutoComplete(
            mbuiContext.dispatcher(), mbuiContext.statementContext(), AddressTemplate.of("/socket-binding-group=*/socket-binding=*")));
        outboundRemoteForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("socket-binding-group-outbound-remote-form", metadata55)
            .include("host", "port", "source-interface", "source-port", "fixed-source-port")
            .unsorted()
            .onSave((form, changedValues) -> presenter.saveSocketBinding(SocketBinding.OUTBOUND_REMOTE, form, changedValues))
            .prepareReset(form -> presenter.resetSocketBinding(SocketBinding.OUTBOUND_REMOTE, form))
            .build();

        outboundLocalTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("socket-binding-group-outbound-local-table", metadata54)
            .button(mbuiContext.resources().constants().add(), table -> presenter.addSocketBinding(SocketBinding.OUTBOUND_LOCAL), Constraint.parse("executable(socket-binding-group=*/local-destination-outbound-socket-binding=*:add)"))
            .button(mbuiContext.resources().constants().remove(), table -> presenter.removeSocketBinding(SocketBinding.OUTBOUND_LOCAL, table.selectedRow().getName()), Scope.SELECTED, Constraint.parse("executable(socket-binding-group=*/local-destination-outbound-socket-binding=*:remove)"))
            .column("name", (cell, type, row, meta) -> SafeHtmlUtils.fromString(row.getName()).asString())
            .build();
        outboundRemoteTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("socket-binding-group-outbound-remote-table", metadata55)
            .button(mbuiContext.resources().constants().add(), table -> presenter.addSocketBinding(SocketBinding.OUTBOUND_REMOTE), Constraint.parse("executable(socket-binding-group=*/remote-destination-outbound-socket-binding=*:add)"))
            .button(mbuiContext.resources().constants().remove(), table -> presenter.removeSocketBinding(SocketBinding.OUTBOUND_REMOTE, table.selectedRow().getName()), Scope.SELECTED, Constraint.parse("executable(socket-binding-group=*/remote-destination-outbound-socket-binding=*:remove)"))
            .column("name", (cell, type, row, meta) -> SafeHtmlUtils.fromString(row.getName()).asString())
            .column("host", (cell, type, row, meta) -> SafeHtmlUtils.fromString(row.get("host").asString()).asString())
            .column("port", (cell, type, row, meta) -> SafeHtmlUtils.fromString(row.get("port").asString()).asString())
            .build();

        navigation = new VerticalNavigation();
        HTMLElement html159;
        HTMLElement socketBindingGroupConfigurationItemElement = section()
            .add(html159 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Socket Binding Group</h1><p>${metadata53.getDescription().getDescription()}</p>"))
                .asElement())
            .add(configurationForm)
            .asElement();
        expressionElements.put("html159", html159);
        navigation.addPrimary("socket-binding-group-configuration-item", "Configuration", "pficon pficon-settings", socketBindingGroupConfigurationItemElement);
        HTMLElement html161;
        HTMLElement socketBindingGroupOutboundLocalItemElement = section()
            .add(html161 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Outbound Local</h1><p>${metadata54.getDescription().getDescription()}</p>"))
                .asElement())
            .add(outboundLocalTable)
            .add(outboundLocalForm)
            .asElement();
        expressionElements.put("html161", html161);
        navigation.addPrimary("socket-binding-group-outbound-local-item", "Outbound Local", "fa fa-arrow-circle-o-right", socketBindingGroupOutboundLocalItemElement);
        HTMLElement html164;
        HTMLElement socketBindingGroupOutboundRemoteItemElement = section()
            .add(html164 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Outbound Remote</h1><p>${metadata55.getDescription().getDescription()}</p>"))
                .asElement())
            .add(outboundRemoteTable)
            .add(outboundRemoteForm)
            .asElement();
        expressionElements.put("html164", html164);
        navigation.addPrimary("socket-binding-group-outbound-remote-item", "Outbound Remote", "fa fa-arrow-circle-right", socketBindingGroupOutboundRemoteItemElement);
        HTMLElement root = row()
            .add(column()
                .addAll(navigation.panes()))
            .asElement();

        registerAttachable(navigation);
        registerAttachable(configurationForm);
        registerAttachable(outboundLocalTable);
        registerAttachable(outboundLocalForm);
        registerAttachable(outboundRemoteTable);
        registerAttachable(outboundRemoteForm);

        initElement(root);

        init();
    }

    @Override
    public void attach() {
        super.attach();

            outboundLocalTable.bindForm(outboundLocalForm);
            outboundRemoteTable.bindForm(outboundRemoteForm);

        TemplateUtil.replaceExpression(expressionElements.get("html159"), "${metadata53.getDescription().getDescription()}", String.valueOf(metadata53.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html161"), "${metadata54.getDescription().getDescription()}", String.valueOf(metadata54.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html164"), "${metadata55.getDescription().getDescription()}", String.valueOf(metadata55.getDescription().getDescription()));
    }
}
