/*
 * Copyright 2015-2016 Red Hat, Inc, and individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.hal.core.ui;

import org.jboss.hal.flow.Progress;

/** Registry which can be used to get references to global UI related instances such as the progress bar in the footer. */
public class UIRegistry {

    private Progress progress = Progress.NOOP;

    public Progress getProgress() {
        return progress;
    }

    public void register(final Progress progress) {
        this.progress = progress;
    }
}
